from flaskext.xmlrpc import XMLRPCHandler, Fault
import fedora.client

from fake_fedorainfra import app
import fake_fedorainfra.lib.mock_koji as mock_koji


handler = XMLRPCHandler('mockkoji')

def decode_args(*args):
    """Decodes optional arguments from a flat argument list

    Complementary to encode_args
    Returns a tuple (args,opts) where args is a tuple and opts is a dict
    """
    print args
    opts = {}
    if len(args) > 0:
        if type(args) == dict:
            return (),args

        last = args[-1]
        if type(last) == dict and last.get('__starstar',False):
            del last['__starstar']
            opts = last
            args = args[:-1]
            # this is a bit of a dirty hack, didn't want to enable
            # allow_none right now
            if args[0] == '__none':
                args = ()

    return args,opts

@handler.register
def getBuild(nvr):
    if nvr is None:
        raise Fault("no_build", "there has to be some build passed in!")

    k = mock_koji.MockKoji()
    return k.get_build(nvr)

@handler.register
def listTagged(args):
    print args
    params, opts = decode_args(*args)
    k = mock_koji.MockKoji()
    return k.get_tags(*params, **opts)

@handler.register
def tagHistory(args):
    print args
    print type(args)
    if type(args) != str:
        params, opts = decode_args(*args)
    else:
        params = (args,)
        opts = {}
    print params
    print opts
    k = mock_koji.MockKoji()
    return k.tag_history(*params, **opts)

@handler.register
def listBuilds(args):
    if type(args) != dict:
        params, opts = decode_args(*args)
    else:
        params = ()
        opts = args
        del opts['__starstar']
    print params
    print opts
    k = mock_koji.MockKoji()
    return k.list_builds(*params, **opts)

